#
# spec file for package perl
#
# Copyright (c) 2022-2023 ZhuningOS
#
# icecream 0


#Compat macro for new _fillupdir macro introduced in Nov 2017
%if ! %{defined _fillupdir}
  %define _fillupdir /var/adm/fillup-templates
%endif

Name:           perl
Summary:        The Perl interpreter
License:        Artistic-1.0 or GPL-2.0+
Group:          Development/Languages/Perl
Version:        5.26.1
Release:        150300.17.14.1
%define pversion 5.26.1
Url:            http://www.perl.org/
Source:         http://www.cpan.org/src/5.0/perl-%{version}.tar.xz
Source1:        %name-rpmlintrc
Source2:        macros.perl
Source3:        README.macros
Source4:        baselibs.conf
Patch0:         perl-5.26.0.dif
Patch2:         perl-regexp-refoverflow.diff
Patch3:         perl-nroff.diff
Patch4:         perl-netcmdutf8.diff
Patch5:         perl-HiRes.t-timeout.diff
Patch6:         perl-saverecontext.diff
# PATCH-FIX-OPENSUSE perl-5.22.0_wrong_rpm_provides.diff Prevent generating bad RPM provides
Patch7:         perl-5.22.0_wrong_rpm_provides.diff
Patch8:         skip_time_hires.patch
Patch9:         perl-incfix.diff
Patch11:        perl-5.18.2-overflow.diff
# PATCH-FIX-OPENSUSE 
Patch12:        perl-reproducible.patch
Patch13:        perl_skip_flaky_tests_powerpc.patch
Patch14:        posix-sigaction.patch
Patch15:        perl-archive-tar-dirtrav.diff
Patch16:        perl-extended-charclass-assert.diff
Patch17:        perl-regcomp-strchr-memchr.diff
Patch18:        perl-reg-node-overrun.diff
Patch19:        perl-setenv-integer-wrap.diff
Patch20:        perl-fix2020.patch
Patch21:        perl-study.diff
Patch22:        perl-saltbits.diff
Patch23:        perl-Stabilize-Socket-VERSION-comparisons.patch
Patch24:        perl-file_path_rmtree_fchmod.diff
Patch25:        perl-cpan_verify_cert.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         perl-base = %version
#PreReq:         %fillup_prereq
BuildRequires:  db-devel
BuildRequires:  gdbm-devel
BuildRequires:  libbz2-devel
BuildRequires:  ncurses-devel
BuildRequires:  xz
BuildRequires:  zlib-devel
#Requires:       gzip	# needed in SuSEconfig.perl
Suggests:       perl-doc = %version
Recommends:     perl-core-DB_File
#
%if "%version" != "%pversion"
Provides:       perl = %pversion-%release
%endif
Provides:       perl-500
Provides:       perl(:MODULE_COMPAT_%pversion)
%global versionlist %nil
Provides:       perl-Filter-Simple = 0.93
Obsoletes:      perl-Filter-Simple <= 0.93
Provides:       perl-I18N-LangTags = 0.42
Obsoletes:      perl-I18N-LangTags <= 0.42
Provides:       perl-MIME-Base64 = 3.15
Obsoletes:      perl-MIME-Base64 <= 3.15
Provides:       perl-Storable = 2.62
Obsoletes:      perl-Storable <= 2.62
Provides:       perl-Test-Simple = 1.302073
Obsoletes:      perl-Test-Simple <= 1.302073
Provides:       perl-Text-Balanced = 2.03
Obsoletes:      perl-Text-Balanced <= 2.03
Provides:       perl-Time-HiRes = 1.9741
Obsoletes:      perl-Time-HiRes <= 1.9741
Provides:       perl-libnet = 3.08
Obsoletes:      perl-libnet <= 3.08
Provides:       perl-Compress-Raw-Zlib = 2.074
Obsoletes:      perl-Compress-Raw-Zlib <= 2.074
Provides:       perl-Compress-Zlib = 2.074
Obsoletes:      perl-Compress-Zlib <= 2.074
Provides:       perl-IO-Compress-Base = 2.074
Obsoletes:      perl-IO-Compress-Base <= 2.074
Provides:       perl-IO-Compress-Zlib = 2.074
Obsoletes:      perl-IO-Compress-Zlib <= 2.074
Provides:       perl-IO-Zlib = 1.10
Obsoletes:      perl-IO-Zlib <= 1.10
Provides:       perl-Archive-Tar = 2.24
Obsoletes:      perl-Archive-Tar <= 2.24
Provides:       perl-Locale-Maketext-Simple = 0.21
Obsoletes:      perl-Locale-Maketext-Simple <= 0.21
Provides:       perl-Pod-Escapes = 1.07
Obsoletes:      perl-Pod-Escapes <= 1.07
Provides:       perl-Pod-Simple = 3.35
Obsoletes:      perl-Pod-Simple <= 3.35
Provides:       perl-ExtUtils-ParseXS = 3.34
Obsoletes:      perl-ExtUtils-ParseXS <= 3.34
Provides:       perl-CPAN-Meta = 2.150010
Obsoletes:      perl-CPAN-Meta <= 2.150010
Provides:       perl-CPAN-Meta-YAML = 0.018
Obsoletes:      perl-CPAN-Meta-YAML <= 0.018
Provides:       perl-ExtUtils-CBuilder = 0.280225
Obsoletes:      perl-ExtUtils-CBuilder <= 0.280225
Provides:       perl-IO-Socket-IP = 0.38
Obsoletes:      perl-IO-Socket-IP <= 0.38
Provides:       perl-Parse-CPAN-Meta = 1.4417
Obsoletes:      perl-Parse-CPAN-Meta <= 1.4417
Provides:       perl-PathTools = 3.63
Obsoletes:      perl-PathTools <= 3.63
Provides:       perl-autodie = 2.29
Obsoletes:      perl-autodie <= 2.29
Provides:       perl-Test-Harness = 3.38
Obsoletes:      perl-Test-Harness <= 3.38
Provides:       perl-version = 0.9917
Obsoletes:      perl-version <= 0.9917

%description
perl - Practical Extraction and Report Language

Perl is optimized for scanning arbitrary text files, extracting
information from those text files, and printing reports based on that
information.  It is also good for many system management tasks. Perl is
intended to be practical (easy to use, efficient, and complete) rather
than beautiful (tiny, elegant, and minimal).

Some of the modules available on CPAN can be found in the "perl"
series.

%package base
Summary:        The Perl interpreter
Group:          Development/Languages/Perl
Provides:       perl-Digest
Provides:       perl-Digest-MD5
%if "%version" != "%pversion"
Provides:       perl-base = %pversion-%release
%endif
# bug437293
%ifarch ppc64
Obsoletes:      perl-64bit
%endif
#

%description base
perl - Practical Extraction and Report Language

Perl is optimized for scanning arbitrary text files, extracting
information from those text files, and printing reports based on that
information.  It is also good for many system management tasks.

Perl is intended to be practical (easy to use, efficient, and complete)
rather than beautiful (tiny, elegant, and minimal).

This package contains only some basic modules and the perl binary
itself.

%package core-DB_File
Summary:        Perl 5 interface to Berkeley DB
Group:          Development/Languages/Perl
Requires:       perl = %version-%release

%description core-DB_File
perl-core-DB_File - Perl 5 interface to Berkeley DB

Perl is optimized for scanning arbitrary text files, extracting
information from those text files, and printing reports based on that
information.  It is also good for many system management tasks.

Perl is intended to be practical (easy to use, efficient, and complete)
rather than beautiful (tiny, elegant, and minimal).

This package contains perl's DB_File module.

%package doc
Summary:        Perl Documentation
Group:          Development/Languages/Perl
Requires:       perl = %{version}
Provides:       perl:/usr/share/man/man3/CORE.3pm.gz
%if 0%{?suse_version} >= 1120
BuildArch:      noarch
%endif
Provides:       perl-macros = 2.0
Obsoletes:      perl-macros < 2.0

%description doc
Perl man pages and pod files.

%prep
%setup -q -n perl-%{pversion}
cp -p %{S:3} .
%patch0
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%ifarch ppc ppc64 ppc64le
%patch8 -p1
%patch13 -p1
%endif
%patch9
%patch11
%patch12 -p1
%patch14 -p1
%patch15
%patch16
%patch17
%patch18
%patch19
%patch20
%patch21
%patch22
%patch23 -p1
%patch24
%patch25

%build
cp -a lib savelib
export SUSE_ASNEEDED=0
export BZIP2_LIB=%{_libdir}
export BZIP2_INCLUDE=%{_includedir}
export BUILD_BZIP2=0
options="-Doptimize='$RPM_OPT_FLAGS -Wall -pipe'"
%ifarch alpha
# -mieee needed for bad alpha gcc optimization
options="-Doptimize='$RPM_OPT_FLAGS -Wall -pipe -mieee'"
%endif
%ifarch ppc ppc64
options="$options -Duse64bitint"
%endif
# this needs an installed perl, sorry
archname=%(perl -V:archname | sed "s!.*='!!;s!'.*!!")
test -n "$archname"
versionlist=
for v in %{?versionlist} ; do
  test "$v" == none || versionlist="$versionlist $v/$archname $v"
done
test -n "$versionlist" || versionlist=none
versionlist=${versionlist# }
# always use glibc's setenv
options="$options -Accflags='-DPERL_USE_SAFE_PUTENV'"
options="$options -Dotherlibdirs=/usr/lib/perl5/site_perl -Dinc_version_list='$versionlist'"
chmod 755 ./configure.gnu
./configure.gnu --prefix=/usr -Dvendorprefix=/usr -Dinstallusrbinperl -Dusethreads -Di_db -Di_dbm -Di_ndbm -Di_gdbm -Dd_dbm_open -Duseshrplib=\'true\' $options
make %{?_smp_mflags}
cp -p libperl.so savelibperl.so
cp -p lib/Config.pm saveConfig.pm
cp -p lib/Config_heavy.pl saveConfig_heavy.pl
##make clean > /dev/null
make clobber
rm -rf lib
mv savelib lib
./configure.gnu --prefix=/usr -Dvendorprefix=/usr -Dinstallusrbinperl -Dusethreads -Di_db -Di_dbm -Di_ndbm -Di_gdbm -Dd_dbm_open $options
make %{?_smp_mflags}

%check
%if !0%{?qemu_user_space_build}
export SUSE_ASNEEDED=0
make test
%endif

%install
make install DESTDIR=$RPM_BUILD_ROOT
cp -a $RPM_BUILD_ROOT/usr/lib/perl5/site_perl $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl
cpa=`echo $RPM_BUILD_ROOT/usr/lib/perl5/*/*/CORE | sed -e 's@/CORE$@@'`
cp=`echo "$cpa" | sed -e 's@/[^/]*$@@'`
vpa=`echo $cpa | sed -e 's@/perl5/@/perl5/vendor_perl/@'`
vp=`echo "$vpa" | sed -e 's@/[^/]*$@@'`
install -d $vp/auto
install -d $vpa/auto
install -m 555 savelibperl.so $cpa/CORE/libperl.so
install -m 444 saveConfig.pm $cpa/Config.pm
install -m 444 saveConfig_heavy.pl $cpa/Config_heavy.pl
#install -d $RPM_BUILD_ROOT/var/adm/SuSEconfig/bin
#install -d $RPM_BUILD_ROOT/sbin/conf.d
#install -d $RPM_BUILD_ROOT%{_fillupdir}
#install -m 755 SuSE/perllocal.SuSE $RPM_BUILD_ROOT/usr/lib/perl5
#install -m 755 SuSE/SuSEconfig.perl $RPM_BUILD_ROOT/sbin/conf.d
#install -m 755 SuSE/sysconfig.suseconfig-perl $RPM_BUILD_ROOT%{_fillupdir}
# install macros.perl file
install -D -m 644 %{S:2} $RPM_BUILD_ROOT%{_sysconfdir}/rpm/macros.perl
pushd /usr/include
( rpm -ql glibc-devel | fgrep '.h' 
  find /usr/include/asm/ -name \*.h
  find /usr/include/asm-generic -name \*.h
  find /usr/include/linux -name \*.h
) | while read f; do
  $RPM_BUILD_ROOT/usr/bin/perl -I$cp -I$cpa $RPM_BUILD_ROOT/usr/bin/h2ph -d $vpa ${f/\/usr\/include\//} || : 
done
popd
d="`gcc -print-file-name=include`"
test -f "$d/stdarg.h" && (cd $d ; $RPM_BUILD_ROOT/usr/bin/perl -I$cp -I$cpa $RPM_BUILD_ROOT/usr/bin/h2ph -d $vpa stdarg.h stddef.h float.h)
# comment out bad warning from features.ph
sed -i -e '/requires. compiling. with. optimization/s/^/#/' $vpa/features.ph
# remove broken pm - we don't have the module
rm -f $RPM_BUILD_ROOT/usr/lib/perl5/*/Pod/Perldoc/ToTk.pm
# we don't need this in here
rm -f $RPM_BUILD_ROOT/usr/lib/perl5/*/*/CORE/libperl.a
#touch $RPM_BUILD_ROOT/usr/share/man/man3/perllocal.3pm
#touch $cpa/perllocal.pod
# test CVE-2007-5116
$RPM_BUILD_ROOT/usr/bin/perl -e '$r=chr(128)."\\x{100}";/$r/'
# test perl-regexp-refoverflow.diff, should not crash or hang
$RPM_BUILD_ROOT/usr/bin/perl -e 'eval "/\\6666666666/"'
$RPM_BUILD_ROOT/usr/bin/perl -e '0 =~ /0(?n)|()(()(()(?0)|(?0)))(0)/'
$RPM_BUILD_ROOT/usr/bin/perl -e '0 =~ /0(?n)|()(()((?0)|(?0)))0*\N0/'
$RPM_BUILD_ROOT/usr/bin/perl -e '"000000"=~/0(?0)|0(?|0|0)/'
%if 0
# remove unrelated target/os manpages
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlaix.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlamiga.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlapollo.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlbeos.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlbs2000.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlcygwin.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perldgux.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perldos.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlepoc.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlfreebsd.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlhpux.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlhurd.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlirix.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlmachten.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlmacos.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlmacosx.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlmint.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlnetware.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlopenbsd.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlos2.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlos390.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlos400.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlplan9.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlqnx.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlsolaris.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perltru64.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perluts.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlvmesa.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlvms.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlvos.1*
rm -f $RPM_BUILD_ROOT/usr/share/man/man1/perlwin32.1*
%endif
cat << EOF > perl-base-filelist
/usr/lib/perl5/%pversion/B/Deparse.pm
/usr/lib/perl5/%pversion/Carp.pm
/usr/lib/perl5/%pversion/Carp/
/usr/lib/perl5/%pversion/Class/
/usr/lib/perl5/%pversion/Config/
/usr/lib/perl5/%pversion/Digest.pm
/usr/lib/perl5/%pversion/Digest/
/usr/lib/perl5/%pversion/English.pm
/usr/lib/perl5/%pversion/Exporter.pm
/usr/lib/perl5/%pversion/Exporter/
/usr/lib/perl5/%pversion/File/
/usr/lib/perl5/%pversion/Getopt/
/usr/lib/perl5/%pversion/IPC/
/usr/lib/perl5/%pversion/Text/
/usr/lib/perl5/%pversion/Tie/Hash.pm
/usr/lib/perl5/%pversion/XSLoader.pm
/usr/lib/perl5/%pversion/warnings.pm
/usr/lib/perl5/%pversion/warnings/
/usr/lib/perl5/%pversion/AutoLoader.pm
/usr/lib/perl5/%pversion/FileHandle.pm
/usr/lib/perl5/%pversion/SelectSaver.pm
/usr/lib/perl5/%pversion/Symbol.pm
/usr/lib/perl5/%pversion/base.pm
/usr/lib/perl5/%pversion/bytes.pm
/usr/lib/perl5/%pversion/bytes_heavy.pl
/usr/lib/perl5/%pversion/constant.pm
/usr/lib/perl5/%pversion/fields.pm
/usr/lib/perl5/%pversion/feature.pm
/usr/lib/perl5/%pversion/integer.pm
/usr/lib/perl5/%pversion/locale.pm
/usr/lib/perl5/%pversion/overload.pm
/usr/lib/perl5/%pversion/overloading.pm
/usr/lib/perl5/%pversion/parent.pm
/usr/lib/perl5/%pversion/strict.pm
/usr/lib/perl5/%pversion/unicore/Heavy.pl
/usr/lib/perl5/%pversion/utf8.pm
/usr/lib/perl5/%pversion/utf8_heavy.pl
/usr/lib/perl5/%pversion/vars.pm
/usr/lib/perl5/%pversion/version.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Data/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Digest/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/File/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/List/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Scalar/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/Dir.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/File.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/Handle.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/Pipe.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/Poll.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/Seekable.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/Select.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/Socket.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/IO/Socket/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/B.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Config.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Config_heavy.pl
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Cwd.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/DynaLoader.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Errno.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Fcntl.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/POSIX.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/Socket.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/attributes.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/Data/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/Digest/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/Fcntl/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/File/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/IO/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/List/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/Cwd/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/Socket/
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/POSIX/POSIX.so
/usr/lib/perl5/%pversion/*-linux-thread-multi*/lib.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/re.pm
EOF
{
  sed -e 's/^/%%exclude /' perl-base-filelist
  (cd $RPM_BUILD_ROOT
   for i in usr/lib/perl5/*/pod/*; do
     case $i in */perldiag.pod) ;;
     *) echo "%%exclude /$i" ;;
     esac
   done)
} > perl-base-excludes
#%%post
#%%{fillup_only -an suseconfig}

%files base -f perl-base-filelist
%defattr(-,root,root)
%license Copying Artistic
%dir /usr/lib/perl5
%dir /usr/lib/perl5/%pversion
%dir /usr/lib/perl5/%pversion/B
%dir /usr/lib/perl5/%pversion/*-linux-thread-multi*
%dir /usr/lib/perl5/%pversion/*-linux-thread-multi*/auto
%dir /usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/POSIX
/usr/bin/perl
/usr/bin/perl%pversion
%doc /usr/share/man/man1/perl.1.gz

%files -f perl-base-excludes 
%defattr(-,root,root)
%exclude /usr/bin/perl
%exclude /usr/bin/perl%pversion
%exclude /usr/lib/perl5/%pversion/*-linux-thread-multi*/DB_File.pm
%exclude /usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/DB_File
/usr/bin/*
/usr/lib/perl5/*
%config %{_sysconfdir}/rpm/macros.perl
#/sbin/conf.d/SuSEconfig.perl
#%{_fillupdir}/sysconfig.suseconfig-perl
#%ghost /usr/lib/perl*/*/*/perllocal.pod
#%ghost %doc /usr/share/man/man3/perllocal.3pm.gz

%files core-DB_File
%defattr(-,root,root)
%license Copying Artistic
/usr/lib/perl5/%pversion/*-linux-thread-multi*/DB_File.pm
/usr/lib/perl5/%pversion/*-linux-thread-multi*/auto/DB_File

%files doc
%defattr(-,root,root)
%doc README.macros
%exclude /usr/share/man/man1/perl.1.gz
%exclude /usr/lib/perl5/*/pod/perldiag.pod
%doc /usr/share/man/man1/*
%doc /usr/share/man/man3/*
%doc /usr/lib/perl5/*/pod

%changelog
